/**********************************************************
* @ File name -> pcf8563.h
* @ Version   -> V1.0
* @ Date      -> 10-20-2013
* @ Brief     -> ʱоƬPCF8563ͷļ 
**********************************************************/

#ifndef _pcf8563_h_ 
#define _pcf8563_h_

/**********************************************************
                     ⲿͷļ
         Ӧõͬͷļ޸ļ                        
**********************************************************/

#include "config.h"

/**********************************************************
                  PCF8563Ĵṹ                          
**********************************************************/
typedef struct
{
	u8 cont1;	///״̬Ĵ1
	u8 cont2;	///״̬Ĵ2
	
	u8 year;	//
	u8 month;	//
	u8 week;	//
	u8 date;	//
	u8 hour;	//Сʱ
	u8 minute;	//
	u8 second;	//
	
	u8 alarmmin;	//ӱ
	u8 alarmhour;	//Сʱ
	u8 alarmdate;	//ձ
	u8 alarmweek;	//ڱ
	
	u8 CLKcont;	//Ƶ
	u8 timecont;	//ʱ
	u8 timeconut;	//ʱʱĴ
}Time_Typedef;

extern Time_Typedef TimeValue;	//ʱݻ

extern u8 data Time_Register[16];	//ʱϢ

/**********************************************************
                        궨                       
**********************************************************/

#define PCF8563_Write			0xa2	//д
#define PCF8563_Read			0xa3	//ãPCF8563_Write + 1

#define Clear_Register			0x00	//Ĵֵ

/**********************************************************
                   Ĵַ궨                    
**********************************************************/

#define Address_control1		0x00	///״̬Ĵ1
#define Address_control2		0x01	///״̬Ĵ2

#define Address_CLKOUT			0x0d	//CLKOUTƵʼĴ
#define Address_Time			0x0e	//ʱƼĴ
#define Address_Time_VAL		0x0f	//ʱĴ

#define Address_year			0x08	//
#define Address_month			0x07	//
#define Address_date			0x05	//
#define Address_week			0x06	//
#define Address_hour			0x04	//Сʱ
#define Address_minute			0x03	//
#define Address_second			0x02	//

#define Alarm_minute			0x09	//ӱ
#define Alarm_hour				0x0a	//Сʱ
#define Alarm_date				0x0b	//ձ
#define Alarm_week				0x0c	//ڱ

/**********************************************************
                ʱЧλ궨                 
**********************************************************/

#define Shield_secondBit			0x7f
#define Shield_minuteBit			0x7f
#define Shield_hourBit				0x3f
#define Shield_weekBit				0x07
#define Shield_dateBit				0x3f
#define Shield_monthBit				0x1f	//bit7λΪΪ0ָΪ20xx
											//                1ָΪ19xx
											//Ĵеֵ99Ϊ00ʱλı

/**********************************************************
                                             
**********************************************************/

#define Set_Year19xx			(1<<7)	//Ϊ19xxģʽ
#define Set_Year20xx			(0<<7)	//Ϊ20xxģʽ

///״̬Ĵ1
#define Control_Test1_Common	(0<<7)	//ͨģʽ
#define Control_Test1_EXT_CLK	(1<<7)	//EXT_CLKģʽ

#define Control_Chip_Run		(0<<5)	//оƬ
#define Control_Chip_Stop		(1<<5)	//оƬֹͣУоƬƵ첽߼0

#define Control_TESTC_Close		(0<<3)	//ԴλʧЧͨģʽʱ߼0
#define Control_TESTC_Open		(1<<3)	//ԴλЧ

///״̬Ĵ2
#define Control_TI_TF1			(0<<4)	//TFЧʱINTЧȡTIE״̬
#define Control_TI_TF2			(1<<4)	//INTЧȡTIE״̬
										//ע⣺AFAIEЧʱINTһֱЧ

#define Control_clear_AF		(0<<3)	//
#define Control_clear_TF		(0<<2)
										//ʱAFֵ߼1ڶʱʱ
										//TFֵ߼1ڱдǰһֱԭֵ
										//ʱͱж϶ʱжԴAFTF
										//Ҫʹһ־λֹһ־λдӦ߼
										//ָAND
#define Alarm_INT_Open			(1<<1)	//жЧ
#define Alarm_INT_Close			(0<<1)	//жЧ

#define Time_INT_Open			(1<<0)	//ʱжЧ
#define Time_INT_Close			(0<<0)	//ʱжЧ

///VLĴ
#define Accuracy_Clock_Yes			(0<<7)	//֤׼ȷʱ/
#define Accuracy_Clock_No			(1<<7)	//֤׼ȷʱ/

//ӱĴ
#define Alarm_minute_Open			(0<<7)	//ӱЧ
#define Alarm_minute_Close			(1<<7)	//ӱЧ

//СʱĴ
#define Alarm_hour_Open				(0<<7)	//СʱЧ
#define Alarm_hour_Close			(1<<7)	//СʱЧ

//ձĴ
#define Alarm_date_Open				(0<<7)	//ձЧ
#define Alarm_date_Close			(1<<7)	//ձЧ

//ڱĴ
#define Alarm_week_Open				(0<<7)	//ڱЧ
#define Alarm_week_Close			(1<<7)	//ڱЧ

//CLKOUTƵʼĴ
#define CLKOUT_Open					(1<<7)	//CLKOUTЧ
#define CLKOUT_Close				(0<<7)	//CLKOUTֹɸ迹

#define CLKOUT_f32768				0x00	//32.768KHz
#define CLKOUT_f1024				0x01	//1024Hz
#define CLKOUT_f32					0x02	//32Hz
#define CLKOUT_f1					0x03	//1Hz

//ʱĴ
#define Time_Open					(1<<7)	//ʱЧ
#define Time_Close					(0<<7)	//ʱЧ

#define Time_f4096					0x00	//ʱʱƵΪ4096Hz
#define Time_f64					0x01	//ʱʱƵΪ64Hz
#define Time_f1						0X02	//ʱʱƵΪ1Hz
#define Time_f160					0X03	//ʱʱƵΪ1/60Hz

/**********************************************************
                       ⲿܺ                      
**********************************************************/

void PCF8563_Write_Byte(u8 REG_ADD,u8 dat);	//PCF8563ĳĴдһֽ

u8 PCF8563_Read_Byte(u8 REG_ADD);	//PCF8563ĳĴȡһֽ

void PCF8563_Operate_Register(u8 REG_ADD,u8 *pBuff,u8 num,u8 mode);	//PCF8563ʱĴдݻ߶ȡ

void PCF8563_Set_Alarm(Time_Typedef *Alarm);	//

void PCF8563_ReadWrite_Time(u8 mode);	//PCF8563ȡдʱϢ

void Time_Init(Time_Typedef *TimeVAL);	//ʱʼ


#endif
 
