/**********************************************************
* @ File name -> pcf8563.c
* @ Version   -> V1.0
* @ Date      -> 10-20-2013
* @ Brief     -> ʱоƬPCF8563 
**********************************************************/

#include "pcf8563.h"

/**********************************************************
                    صı
**********************************************************/

Time_Typedef TimeValue;	//ʱָ

u8 Time_Buffer[16];	//ʱݻ

/**********************************************************
*  ---> PCF8563ĳĴдһֽ
* ڲ ---> REG_ADDҪĴַ
*               datҪд
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void PCF8563_Write_Byte(u8 REG_ADD,u8 dat)
{
	IIC_Start();
	if(!(IIC_Write_Byte(PCF8563_Write)))	//дӦλ
	{
		IIC_Write_Byte(REG_ADD);
		IIC_Write_Byte(dat);	//
	}
	IIC_Stop();
} 
/**********************************************************
*  ---> PCF8563ĳĴȡһֽ
* ڲ ---> REG_ADDҪĴַ
* ֵ ---> none
* ˵ ---> none
**********************************************************/
u8 PCF8563_Read_Byte(u8 REG_ADD)
{
	u8 ReData;
	IIC_Start();
	if(!(IIC_Write_Byte(PCF8563_Write)))	//дӦλ
	{
		IIC_Write_Byte(REG_ADD);	//ȷҪļĴ
		IIC_Start();	//
		IIC_Write_Byte(PCF8563_Read);	//Ͷȡ
		ReData = IIC_Read_Byte();	//ȡ
		IIC_Ack(1);	//ͷӦźŽݴ
	}
	IIC_Stop();
	return ReData;
}
/**********************************************************
*  ---> PCF8563ʱĴдݻ߶ȡ
* ڲ ---> REG_ADDҪĴʼַ
*               *WBuffдݻ
*               numд
*               modeģʽ0дݲ1ȡݲ
* ֵ ---> none
* ˵ ---> дnֽڻȡnֽ
**********************************************************/	
void PCF8563_Operate_Register(u8 REG_ADD,u8 *pBuff,u8 num,u8 mode)
{
	u8 i;
	if(mode)	//ȡ
	{
		IIC_Start();
		if(!(IIC_Write_Byte(PCF8563_Write)))	//дӦλ
		{
			IIC_Write_Byte(REG_ADD);	//λʼĴַ
			IIC_Start();	//
			IIC_Write_Byte(PCF8563_Read);	//Ͷȡ
			for(i = 0;i < num;i++)
			{
				*pBuff = IIC_Read_Byte();	//ȡ
				if(i == (num - 1))	IIC_Ack(1);	//ͷӦź
				else IIC_Ack(0);	//Ӧź
				pBuff++;
			}
		}
		IIC_Stop();	
	}
	else	//д
	{		 	
		IIC_Start();
		if(!(IIC_Write_Byte(PCF8563_Write)))	//дӦλ
		{
			IIC_Write_Byte(REG_ADD);	//λʼĴַ
			for(i = 0;i < num;i++)
			{
				IIC_Write_Byte(*pBuff);	//д
				pBuff++;
			}
		}
		IIC_Stop();
	}
}
/**********************************************************
*  ---> PCF8563ȡдʱϢ
* ڲ ---> *pBuffдݻ
*               modeģʽ0дݲ1ȡݲ
* ֵ ---> none
* ˵ ---> дnֽڻȡnֽ
**********************************************************/
void PCF8563_ReadWrite_Time(u8 mode)
{
	u8 Time_Register[8];	//ʱ仺
	
	if(mode)	//ȡʱϢ
	{
		PCF8563_Operate_Register(Address_second,Time_Register,7,1);	//ַ0x02ʼȡʱ
		
		/******ݸƵʱṹУ******/
		TimeValue.second = Time_Register[0] & Shield_secondBit;	//
		TimeValue.minute = Time_Register[1] & Shield_minuteBit;	//
		TimeValue.hour = Time_Register[2] & Shield_hourBit;	//Сʱ
		TimeValue.date = Time_Register[3] & Shield_dateBit;	//
		TimeValue.week = Time_Register[4] & Shield_weekBit;	//
		TimeValue.month = Time_Register[5] & Shield_monthBit;	//
		TimeValue.year = Time_Register[6];	//
	}
	else
	{
		/******ʱṹиݽ******/
		Time_Register[0] = TimeValue.second | Accuracy_Clock_Yes;	//룬֤׼ȷʱ
		Time_Register[1] = TimeValue.minute;	//
		Time_Register[2] = TimeValue.hour;	//Сʱ
		Time_Register[3] = TimeValue.date;	//
		Time_Register[4] = TimeValue.week;	//
		Time_Register[5] = TimeValue.month | (0<<7);	//£λ20xx
		Time_Register[6] = TimeValue.year;	//
		
//		PCF8563_Write_Byte(Address_control1,Control_Chip_Stop);	//оƬֹͣ
		PCF8563_Operate_Register(Address_second,Time_Register,7,0);	//ַ0x00ʼдʱ
//		PCF8563_Write_Byte(Address_control1,Control_Chip_Run);	//оƬ
	}
}

/**********************************************************
*  ---> ʱʼ
* ڲ ---> *TimeVALRTCоƬĴֵָ
* ֵ ---> none
* ˵ ---> none
**********************************************************/
void Time_Init(Time_Typedef *TimeVAL)
{	
	///״̬Ĵ
	Time_Buffer[0] = TimeVAL->cont1;	///״̬Ĵ1
	Time_Buffer[1] = TimeVAL->cont2;	///״̬Ĵ2
	//ʱ
	Time_Buffer[2] = TimeVAL->second | Accuracy_Clock_Yes;	//֤׼ȷʱ
	Time_Buffer[3] = TimeVAL->minute;
	Time_Buffer[4] = TimeVAL->hour;
	Time_Buffer[5] = TimeVAL->date;
	Time_Buffer[6] = TimeVAL->week;
	Time_Buffer[7] = TimeVAL->month | Set_Year20xx;	//Ϊ20xx
	Time_Buffer[8] = TimeVAL->year;
	//屨
	Time_Buffer[9] = TimeVAL->alarmmin | Alarm_minute_Close;	//ӱ
	Time_Buffer[10] = TimeVAL->alarmhour | Alarm_hour_Close;	//Сʱ
	Time_Buffer[11] = TimeVAL->alarmdate | Alarm_date_Close;	//ձ
	Time_Buffer[12] = TimeVAL->alarmweek | Alarm_week_Close;	//ڱ
	//Ƶãʱ
	Time_Buffer[13] = TimeVAL->CLKcont;	//Ƶ
	Time_Buffer[14] = TimeVAL->timecont;	//ʱ
	Time_Buffer[15] = TimeVAL->timeconut;	//ʱʱ
	
//	PCF8563_Write_Byte(Address_control1,Control_Chip_Stop);	//оƬֹͣ
	PCF8563_Operate_Register(Address_control1,Time_Buffer,16,0);	//ӿ/״̬Ĵ10x00ʼд16
//	PCF8563_Write_Byte(Address_control1,Control_Chip_Run);	//оƬ
}

